unit uTestMySQL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    stDBServer: TStaticText;
    edSQLServerName: TEdit;
    stDBDatabase1: TStaticText;
    edSQLServerDB: TEdit;
    stDBUser: TStaticText;
    edSQLServerUser: TEdit;
    stDBPassword: TStaticText;
    edSQLServerPW: TEdit;
    StaticText1: TStaticText;
    edDBPort: TEdit;
    btnStart: TButton;
    stDBDatabase2: TStaticText;
    edSQLServerDB2: TEdit;
    procedure btnStartClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;

implementation

uses ADODB, ADOInt;
{$R *.dfm}

const
  CRLF = Chr(13)+Chr(10);    // kein resourcestring, da er sonst nicht zu anderen resourcestrings verknpft werden kann

  var
  SQL_SERVER_CONNECTION_TIMEOUT : Integer = 120;
  SQL_SERVER_COMMAND_TIMEOUT    : Integer = 120;


FUNCTION ConnectionToDatabase(aServer, aUser, aPwd, aPort : STRING) : TADOConnection;
VAR aConnection : TADOConnection;
    compi : String;
BEGIN
  aConnection                   := TADOConnection.Create(Nil);
  aConnection.ConnectionTimeout := SQL_SERVER_CONNECTION_TIMEOUT;
  aConnection.CommandTimeout    := SQL_SERVER_COMMAND_TIMEOUT;

  aConnection.ConnectionString  := 'Provider=MSDASQL.1;'+
                                   'DRIVER={MySQL ODBC 3.51 Driver}'+
                                   ';SERVER ='+aServer+
                                   ';PORT   ='+aPort+
                                   ';OPTION =3'+
                                   ';UID    ='+aUser+
                                   ';PWD    ='+aPwd;

  aConnection.LoginPrompt := FALSE;
  Result := aConnection;
END;

function GetFieldList(table: String; sC : TADoConnection): String;
resourcestring
  rs_Error_GetTableDef = 'Error on reading tabledef of %s !';
VAR DS         : TADODataSet;
    name       : ShortString;
    AT         : TADOTable;
BEGIN
  DS := TADODataSet.Create(Nil);
  AT := TADOTable.Create(Nil);
  AT.Connection := sC;
  result := '';
  try
    sC.OpenSchema(siColumns, VarArrayOf([Unassigned, Unassigned, table, Unassigned]), EmptyParam, DS);
    AT.TableName := table;
    AT.Open;
    DS.First;
    WHILE NOT DS.Eof DO BEGIN
      name := DS.FieldByName('COLUMN_NAME').AsString;
      if result = '' then
        result := name
      else
        result := result + ', '+name;
      DS.Next;
    END;
    AT.Close;
  except
    On E: Exception do
    begin
      MessageDlg(Format(rs_Error_GetTableDef,[table])
        +CRLF + E.Message, mtError, [mbOK], 0);
      Result := '';
    end;
  end;
  AT.Free;
  DS.Free;
end;

procedure TForm2.btnStartClick(Sender: TObject);
VAR aConnection    : TADOConnection;
    fieldlist: String;
    o : OLEVariant;
begin
   aConnection := ConnectionToDatabase(Trim(edSQLServerName.Text),
                                       Trim(edSQLServerUser.Text),
                                       Trim(edSQLServerPW.Text),
                                       Trim(edDBPort.text));
   aConnection.Open;

   // create DB 1
   try
     aConnection.ConnectionObject.Execute('DROP DATABASE ' + Trim(edSQLServerDB.Text), O, adCmdText + adExecuteNoRecords)
   except
   end;
   aConnection.ConnectionObject.Execute('CREATE DATABASE ' + Trim(edSQLServerDB.Text), O, adCmdText + adExecuteNoRecords);
   aConnection.ConnectionObject.Execute('USE ' + Trim(edSQLServerDB.Text), O, adCmdText + adExecuteNoRecords);
   aConnection.ConnectionObject.Execute('CREATE TABLE sqlabfragen(`id`INT auto_increment  NOT NULL, PRIMARY KEY (id) , `name`VARCHAR(250) NOT NULL, `bemerkung`TEXT, `abfrage`TEXT, `abfrageSQLServer`TEXT, `abfrageMYSQLServer`TEXT, `aktiv`BIT, `Vorgabe`BIT, `Laenderversion`INT)', O, adCmdText + adExecuteNoRecords);

   // create DB 2
   try
     aConnection.ConnectionObject.Execute('DROP DATABASE ' + Trim(edSQLServerDB2.Text), O, adCmdText + adExecuteNoRecords)
   except
   end;
   aConnection.ConnectionObject.Execute('CREATE DATABASE ' + Trim(edSQLServerDB2.Text), O, adCmdText + adExecuteNoRecords);
   aConnection.ConnectionObject.Execute('USE ' + Trim(edSQLServerDB2.Text), O, adCmdText + adExecuteNoRecords);
   aConnection.ConnectionObject.Execute('CREATE TABLE sqlabfragen(`id`INT auto_increment  NOT NULL, PRIMARY KEY (id) , `name`VARCHAR(250) NOT NULL, `bemerkung`TEXT, `abfrage`TEXT, `abfrageSQLServer`TEXT, `abfrageMYSQLServer`TEXT, `aktiv`BIT, `Vorgabe`BIT, `Laenderversion`INT)', O, adCmdText + adExecuteNoRecords);


   aConnection.ConnectionObject.Execute('USE ' + Trim(edSQLServerDB.Text), O, adCmdText + adExecuteNoRecords);

   fieldlist := GetFieldList('sqlabfragen',aConnection);

end;

end.
